// ======================================================================
//
// MenuVerticalSliderBar.h
// hugh david & ~Chuck Karpiak
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef MENU_VERTICAL_SLIDER_BAR_H
#define MENU_VERTICAL_SLIDER_BAR_H

// ======================================================================

class    Bitmap;
#include "MenuElement.h"

// ======================================================================

class MenuVerticalSliderBar : public MenuElement
{
	protected:

		real   percentage;

		int    yOffset;
		int    eventNumber;
		int    sliderBarHeight;
		int    sliderBarYHotSpot;
		Bitmap *bitmap;
		bool   pressingLeftMouse;

	private:

		MenuVerticalSliderBar(const MenuVerticalSliderBar &);
		MenuVerticalSliderBar &operator =(const MenuVerticalSliderBar &);

		void             calculatePercentage(int mouseY);
		void             calculateYOffset(void);
		void             clampYOffset(void);

	public:

		MenuVerticalSliderBar(MenuElement *newParent, int maxWidth, int maxHeight, Iff *iff=NULL);
		virtual ~MenuVerticalSliderBar(void);

		void             load(Iff *iff);

		virtual IoResult event(IoEventStruct *event);
		virtual void     menuDraw(int x, int y) const;

		real             getPercentage(void) const;
		void             setPercentage(real newPercentage);
};

// ======================================================================

inline real MenuVerticalSliderBar::getPercentage(void) const
{
	return percentage;
}

// ======================================================================

#endif
